#! /usr/bin/env pike

#pike __REAL_VERSION__

constant description = "Spear mixed C and Pike up.";

int uniq_id_last_time=time();
int uniq_id_sn;
string gen_new_uniq_id()/*{{{*/
{
	if(time()!=uniq_id_last_time){
		uniq_id_last_time=time();
		uniq_id_sn=0;
	}
	return sprintf("%d_%d_%d",getpid(),uniq_id_last_time,uniq_id_sn++);
}/*}}}*/

//defines=({({"__pike__0001","code..."})});
//args=({({({"int","__var__001"}),"t+1"})});

array c_wrap(array a,array defines,array args) 
{ 
	string func_name="__c__"+gen_new_uniq_id();
	array define_names=column(defines,0);

	//write("define_names=%O\n",define_names);

	//write("a=%O",a*" "/"\n");
	//map(a*" "/"\n",lambda(string s){write("T:%O\n",s+"\n");});
	array code=map(a*" "/"\n",lambda(string s){return sprintf("%O",s+"\n");});
	//write("%s",code*"\n");
	string define_inside=(map(define_names,lambda(string s){return sprintf("%O:%s",s,s);})+
			 map(args,lambda(array a){return sprintf("%O:%O",a[0][1],(["int":0,"string":""])[a[0][0]]);})
			)*",";

	string eval_inside=(map(define_names,lambda(string s){return sprintf("%O:%s",s,s);})+
			 map(args,lambda(array a){return sprintf("%O:%s",a[0][1],a[1]);})
			)*",";
	//res+=({column(defines,1)});
	string res=column(defines,1)*"\n"+sprintf("object %s=C.compile(%O,0,%s,([%s]));%s->eval(([%s]));",func_name,"/tmp/"+func_name,code*"\n",
			define_inside,
			func_name,eval_inside);
	return ({({res}),({}),({})}); 
}

array pike_wrap(array a,array defines,array args) 
{ 
	string func_name="__pike__"+gen_new_uniq_id();
	string res=sprintf("apply($(%s)%s);",func_name,(({""})+map(args,lambda(array a){return a[1];}))*",");
	string code=a*" ";
	string def=sprintf("int %s(%s){%s};",func_name,map(args,lambda(array a){return sprintf("%s %s",a[0][0],a[0][1]);})*",",code);
	return ({({res}),defines+({({func_name,def})}),({})}); 
}
array pike_int_wrap(array a,array defines,array args) 
{ 
	string func_name="__pikeint__"+gen_new_uniq_id();
	string res=sprintf("apply($(%s))",func_name);
	string code="return "+a*" "+";";
	string def=sprintf("int %s(%s){%s};",func_name,map(args,lambda(array a){return sprintf("%s %s",a[0][0],a[0][1]);})*",",code);
	return ({({res}),defines+({({func_name,def})}),args/*+({({({"int",func_name}),func_name})})*/}); 
}
array pike_float_wrap(array a,array defines,array args) 
{ 
	string func_name="__pikefloat__"+gen_new_uniq_id();
	string res=sprintf("apply_as_float($(%s))",func_name);
	string code="return "+a*" "+";";
	string def=sprintf("float %s(%s){%s};",func_name,map(args,lambda(array a){return sprintf("%s %s",a[0][0],a[0][1]);})*",",code);
	return ({({res}),defines+({({func_name,def})}),args/*+({({({"float",func_name}),func_name})})*/}); 
}
array pike_string_wrap(array a,array defines,array args)
{
	string func_name="__pikestring__"+gen_new_uniq_id();
	string res=sprintf("apply_as_string($(%s))",func_name);
	string code="return "+a*" "+";";
	string def=sprintf("string %s(%s){%s};",func_name,map(args,lambda(array a){return sprintf("%s %s",a[0][0],a[0][1]);})*",",code);
	return ({({res}),defines+({({func_name,def})}),args/*+({({({"int",func_name}),func_name})})*/}); 
}
array c_int_wrap(array a,array defines,array args)
{
	string var_name="__cint__"+gen_new_uniq_id();
	
	return ({({var_name}),defines,args+({({({"int",var_name}),a*" "})})}); 
}
array c_float_wrap(array a,array defines,array args)
{
	string var_name="__cfloat__"+gen_new_uniq_id();
	
	return ({({var_name}),defines,args+({({({"float",var_name}),a*" "})})}); 
}
array c_string_wrap(array a,array defines,array args)
{
	string var_name="__cstring__"+gen_new_uniq_id();
	
	return ({({var_name}),defines,args+({({({"string",var_name}),a*" "})})}); 
}

array match_para_inside(array a,int i)/*{{{*/
{
	int count=1;
	int begin=i;
	for(;i<sizeof(a);i++){
		if(a[i]=="{"){
			count++;
		}else if(a[i]=="}"){
			count--;
			if(count==0){
				return a[begin..i-1];
			}
		}
	}
}/*}}}*/

array match_para(array a,int i,function wrapper,array defines,array args,int is_c_para)
{
	array para=match_para_inside(a,i+2);
	array defines1;
	array args1;
	array out;
	[out,defines1,args1]=wrapper(@do_precpp(para,is_c_para));
	return ({out,defines+defines1,args+args1,sizeof(para)+3});

}

array do_precpp(array a,int in_c_para)
{
	array res=({});
	array defines=({});
	array args=({});
	for(int i=0;i<sizeof(a);i++){
		array out;
		int adv;
		if(a[i]=="C"&&a[i+1]=="{"){
			[out,defines,args,adv]=match_para(a,i,c_wrap,defines,args,1);
		}else if(a[i]=="P"&&a[i+1]=="{"){
			[out,defines,args,adv]=match_para(a,i,pike_wrap,defines,args,0);
		}else if(a[i]=="INT"&&a[i+1]=="{"){
			if(in_c_para){
				[out,defines,args,adv]=match_para(a,i,pike_int_wrap,defines,args,0);
			}else{
				[out,defines,args,adv]=match_para(a,i,c_int_wrap,defines,args,1);
			}
		}else if(a[i]=="STRING"&&a[i+1]=="{"){
			if(in_c_para){
				[out,defines,args,adv]=match_para(a,i,pike_string_wrap,defines,args,0);
			}else{
				[out,defines,args,adv]=match_para(a,i,c_string_wrap,defines,args,1);
			}
		}else if(a[i]=="FLOAT"&&a[i+1]=="{"){
			if(in_c_para){
				[out,defines,args,adv]=match_para(a,i,pike_float_wrap,defines,args,0);
			}else{
				[out,defines,args,adv]=match_para(a,i,c_float_wrap,defines,args,1);
			}
		}else{
			res+=({a[i]});
		}
		if(out){
			res+=out;
			i+=adv-1;
		}
	}
	return ({res,defines,args});
}

string precpp(string src)
{
	array a=Parser.Pike.split(src);
	string res=do_precpp(a,0)[0]*" ";
//	write("%s",res);
	return res;
}


void clear()
{
	Process.system(sprintf("rm -f /tmp/__c__%d_*.c",getpid()));
	Process.system(sprintf("rm -f /tmp/__c__%d_*.so",getpid()));
}

class MyMaster{
	inherit "/master";
program compile_string(string src,mixed ... args)
{
	return ::compile_string(precpp(src),@args);
}

program compile_file(string filename, object|void handler ,mixed ... args)
{
	return compile(cpp(precpp(master()->master_read_file(filename)),
				filename,
				1,
				handler,
				master()->compat_major,
				master()->compat_minor),@args);
}
}

int main(int argc,array argv)
{
	object master=MyMaster();
	replace_master(master);
        //add_constant("compile_string",compile_string);
        //add_constant("compile_file",compile_file);
/*
        program p=my_compile_string(
#"
void demo(int arg1,string arg2)
{
	C.INCLUDE(\"#include<stdio.h>\\n#include<string.h>\");
	C.CC(\"gcc -g -shared -fPIC\");

	int t1=48;
	string s;
	C{
		int t=32;
		char* s=\"hello world!\";

		P{arg1=INT{t};}
		t=INT{t1};
		P{s=STRING{s};}
	}
	write(\"OK\\n\");
}"

);
        object a=p();
        a->demo(2,"haha");
	*/

	if(sizeof(argv)>1){
		program loader=master->compile_file(argv[1]);
		object run=loader();
		int res=run->main(argc-1,argv[1..]);
		clear();
		return res;
	}
}
